#ifndef CLIENT_GLCLIENT_H
#define CLIENT_GLCLIENT_H

#include <Client/Client.h>

#include <SDL.h>
#include <GL/gl.h>

// FIXME: Due to some NVIDIA includes, I had to add this for linux.
#ifndef WIN32
#undef GLAPIENTRY
#undef GLAPI
#define GLAPIENTRY
#define GLAPI
#endif
#include <GL/glu.h>

// When using windows, GL/gl.h includes windows.h, which defines min and max
// as macro. This might cause name clashes with the respective Ark functions.
#undef max
#undef min

namespace Client
{

   // Renderer-dependent client
   class GLClient : public Client
   {
      public:
	 int m_Width, m_Height;
	 scalar m_NearPlane, m_FarPlane;
	 bool m_Done;
	 UIRenderer *m_UI;

      public:
	 GLClient (int argc, char **argv);
	 ~GLClient ();

	 virtual int Loop ();
	 virtual bool ProcessEvents ();
	 virtual bool HandleEvent (SDL_Event *event);

	 ///
	 virtual void HandleKey (bool down, int mods, int key) {}
	 virtual void HandleMButton (bool down, int b, int x, int y) {}
	 virtual void HandleMotion (int state, int x, int y) {}
	 virtual bool Refresh ();

	 ///
	 inline void SetNearAndFarPlanes(scalar n, scalar f) { m_NearPlane = n; m_FarPlane = f; }
   };

}

#endif
