/*
** ArkRPG - Libraries, Tools & Programs for MMORPG developpements.
** Copyright (C) 1999-2000 The Contributors of the ArkRPG Project
** Please see the file "AUTHORS" for a list of contributors
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif 

#include <Client/LabelWidget.h>

namespace Client
{
   LabelWidget::LabelWidget(const Ark::String& text)
   {
      m_Text = text;
   }
   
   void LabelWidget::SetText(const Ark::String& text)
   {
      m_Text = text;
   }
   
   void
   LabelWidget::SetPosition(int x, int y)
   {
      m_X = x;
      m_Y = y;
   }

   
   const Ark::String& LabelWidget::GetText() const
   {
      return m_Text;
   }
   
   void LabelWidget::Render(UIRenderer* renderer)
   {
      //FIXME: change the name of the font which is now hardcoded
      //FIXME: by default the anchor point of the font is set to CENTER_LEFT.

      renderer->DrawString("arial1-2-7396fa",
		    m_Text,
		    m_X, m_Y);
   }
}
