#ifndef MESSAGE_VIEW_H
#define MESSAGE_VIEW_H

#include <Client/GLClient.h>
#include <Client/TerrainView.h>

namespace Client
{
   struct MessageLabel
   {
	 Ark::String m_Msg;
	 Ark::String m_Reply;
	 Ark::Texture *m_Image;
	 Ark::Entity *m_MyEntity;
	 Ark::Entity *m_DestEntity;

	 int m_X, m_Y;

      public:
	 MessageLabel ();
	 MessageLabel (int xpos, int ypos,
		       Ark::Entity *my,
		       const Ark::String &msg,
		       Ark::Entity *dest = NULL);

	 MessageLabel (int xpos, int ypos,
		       Ark::Texture *image);

	 ~MessageLabel();
		       
	 void Render(UIRenderer *ui);

	 bool HandleMButton (bool down, int b, int x, int y);
   };

   class MessageView
   {
	 Ark::Entity *m_PlayerEntity;
	 Ark::Texture *m_Image;

	 std::vector <MessageLabel> m_Children;

      public:
	 MessageView ();
	 ~MessageView ();
	 void UpdateChildren (UIRenderer *ui, Ark::Entity *ent);
	 void Render(UIRenderer *ui, Ark::Entity *ent);

	 bool HandleMButton (bool down, int b, int x, int y);
   };

}

#endif
