#ifndef CLIENT_TERRAINVIEW_H
#define CLIENT_TERRAINVIEW_H

#include <Client/GLClient.h>

namespace Client
{
   
   class MessageView;

   class TerrainView : public Widget
   {
	 // The last "thing" the mouse pointer hit.
	 Ark::Collision m_LastHit;

	 Ark::Timer m_Timer;
	 Ark::Vector3 m_LastMousePos;
	 scalar m_RotY, m_RotYSpeed;
	 scalar m_RotX, m_RotXSpeed;
	 scalar m_Scale, m_ScaleSpeed;
	 Client *m_Client;
	 MessageView *m_MessageView;

	 Ark::Timer m_FrameTimer;
	 int m_FrameCounter;
	 scalar m_FPS;

	 Ark::Vector3 TraceMousePos (const Ark::Vector3 &pointofview);
      
      public:
	 TerrainView (Client *client);
	 virtual ~TerrainView ();

	 void Render (UIRenderer *ui);

	 void HandleMButton (bool down, int b, int x, int y);
	 void HandleKey (bool down, int mods, int key);
	 void HandleMotion (int state, int x, int y);
   };
}

#endif

