/* $Id: PartSys.cpp,v 1.1 2002/08/28 22:44:53 mrq Exp $
**
** ArkRPG - Libraries, Tools & Programs for MMORPG developpements.
** Copyright (C) 1999-2000 The Contributors of the ArkRPG Project
** Please see the file "AUTHORS" for a list of contributors
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "config.h"

#ifdef WIN32
#include <windows.h>
#endif

#include "PartSys.h"
#include "Visual.h"
#include <GL/gl.h>

namespace Ark
{
void
GLParticleSys::Render ()
{
	std::vector<Particle>::iterator cur = m_Particles.begin();

  if (cur == m_Particles.end())
    return;

  /* ====== LINE ======= */
  if (cur->m_Template->m_pType == ParticleTmpl::TYPE_LINE)
  {
#if 0
    glDisable (GL_TEXTURE_2D);
    glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
//    glEnable (GL_BLEND);

    glBegin (GL_LINES);

    while (cur != m_Particles.end())
    {
      if (!cur->m_Dead)
      {
        Vector3 pos = cur->m_Pos;
        Vector3 vel = cur->m_Vel.GetUnitVector();

//      scalar alpha = 1.0 - (cur->m_Age / cur->m_LifeTime);
//      glColor4f (1.0, 1.0, 1.0, alpha);
        glColor4fv (&cur->m_Template->m_Color.R);

        glVertex3fv (&pos.X);
        pos += vel.Scale (cur->m_Template->m_LineLength);
        glVertex3fv (&pos.X);
      }

      cur++;
    }

    glEnd ();
#endif
  }
  /* ====== SPRITE ======= */
  else if (cur->m_Template->m_pType == ParticleTmpl::TYPE_SPRITE)
  {
#if 0
    if (cur->m_Template->m_Sprite)
      ((GLTexture*)cur->m_Template->m_Sprite)->Bind ();
    else
      glDisable (GL_TEXTURE_2D);

    glEnable (GL_BLEND);
    glDisable (GL_LIGHTING);
    glDisable (GL_CULLFACE);

    while (cur != m_Particles.end())
    {
      if (!cur->m_Dead)
      {
        scalar mat[4][4];
        scalar rad = cur->m_Template->m_Radius;

	cur->m_Template->m_Color.A = 1.0 - (cur->m_Age / cur->m_LifeTime);

        glMatrixMode (GL_MODELVIEW);
        glPushMatrix ();

        /* Set a matrix with no rotation */
        glTranslatef (cur->m_Pos.X, cur->m_Pos.Y, cur->m_Pos.Z);
        glGetFloatv(GL_MODELVIEW_MATRIX, (scalar*)mat);
        mat[0][0] = mat[1][1] = mat[2][2] = 1;
        mat[0][1] = mat[0][2] = mat[1][0] = 0;
        mat[1][2] = mat[2][0] = mat[2][1] = 0;
	glLoadMatrixf ((scalar*)mat);

        glBegin (GL_QUADS);
          glColor4fv (&cur->m_Template->m_Color.R);

          glTexCoord2f (0,0); glVertex3f (-rad, -rad, 0);
          glTexCoord2f (1,0); glVertex3f (+rad, -rad, 0);
          glTexCoord2f (1,1); glVertex3f (+rad, +rad, 0);
          glTexCoord2f (0,1); glVertex3f (-rad, +rad, 0);
        glEnd ();

        /* Restore the old matrix (with rotations) */
        glPopMatrix ();
      }

      cur++;
    }
#endif
  }
}

}
